import Graph from 'graphology';
import { Providers, LayoutAlgorithm } from './layout-creator-usecase';

/**
 * This is our Product
 */

export abstract class Layout<provider extends Providers> {
  constructor(
    public provider: provider,
    public algorithm: LayoutAlgorithm<provider>
  ) {
    console.log(
      `Created the following Layout: ${provider} - ${this.algorithm}`
    );
  }

  public layout(graph: Graph) {
    console.log(`${this.provider} [${this.algorithm}] layouting now`);

    graph.forEachNode((node) => {
      const attr = graph.getNodeAttributes(node);
      if(!attr.hasOwnProperty('x')){
        graph.setNodeAttribute(node, 'x', Math.random());
      }
      if(!attr.hasOwnProperty('y')){
        graph.setNodeAttribute(node, 'y', Math.random());
      }
    });
  }
}
